diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/tx-duration-test.cc ns-3.45/src/wifi/test/tx-duration-test.cc
--- ns-3.44/src/wifi/test/tx-duration-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/tx-duration-test.cc	2025-06-01 20:34:45.634702200 -0700
@@ -2165,72 +3282,78 @@
 
     // 40 MHz band, MU-MIMO, 3 users
     AddTestCase(
-        new HeSigBDurationTest(
-            {{{HeRu::RU_484_TONE, 1, true}, 4, 3},
-             {{HeRu::RU_484_TONE, 1, true}, 5, 2},
-             {{HeRu::RU_484_TONE, 1, true}, 6, 1}},
+        new MuSigDurationTest(
+            {{HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 4, 3},  // CC1
+             {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 5, 2},  // CC2
+             {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 6, 1}}, // CC1
             VhtPhy::GetVhtMcs4(),
             MHz_u{40},
-            HeSigBDurationTest::MU_MIMO,
+            0,
+            MuSigDurationTest::MU_MIMO,
             {200, 200},
             std::make_pair(2, 1), // 2 users in content channel 1 and 1 user in content channel 2
             MicroSeconds(4)),     // one OFDM symbol
         TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 4 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_484_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 5, 2},
-                     {{HeRu::RU_484_TONE, 1, true}, 6, 3},
-                     {{HeRu::RU_484_TONE, 1, true}, 7, 2}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 4, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 5, 2},  // CC2
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 6, 3},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 7, 2}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{40},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {200, 200},
                     std::make_pair(2, 2), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 6 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_484_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 5, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 6, 2},
-                     {{HeRu::RU_484_TONE, 1, true}, 7, 2},
-                     {{HeRu::RU_484_TONE, 1, true}, 8, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 9, 1}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 4, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 5, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 6, 2},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 7, 2},  // CC2
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 9, 1}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{40},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {200, 200},
                     std::make_pair(3, 3), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 8 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_484_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 5, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 6, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 7, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 8, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 9, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 10, 1},
-                     {{HeRu::RU_484_TONE, 1, true}, 11, 1}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 4, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 5, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 6, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 7, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 9, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 10, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 11, 1}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{40},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {200, 200},
                     std::make_pair(4, 4), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 2 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_996_TONE, 1, true}, 11, 1}, {{HeRu::RU_996_TONE, 1, true}, 10, 4}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 11, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 10, 4}}, // CC2
                     VhtPhy::GetVhtMcs5(),
                     MHz_u{80},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208},
                     std::make_pair(1, 1), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
@@ -2238,135 +3361,144 @@
 
     // 80 MHz band, MU-MIMO, 3 users
     AddTestCase(
-        new HeSigBDurationTest(
-            {{{HeRu::RU_996_TONE, 1, true}, 4, 3},
-             {{HeRu::RU_996_TONE, 1, true}, 5, 2},
-             {{HeRu::RU_996_TONE, 1, true}, 6, 1}},
+        new MuSigDurationTest(
+            {{HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 4, 3},  // CC1
+             {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 5, 2},  // CC2
+             {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 6, 1}}, // CC1
             VhtPhy::GetVhtMcs4(),
             MHz_u{80},
-            HeSigBDurationTest::MU_MIMO,
+            0,
+            MuSigDurationTest::MU_MIMO,
             {208, 208, 208, 208},
             std::make_pair(2, 1), // 2 users in content channel 1 and 1 user in content channel 2
             MicroSeconds(4)),     // one OFDM symbol
         TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 4 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_996_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 5, 2},
-                     {{HeRu::RU_996_TONE, 1, true}, 6, 3},
-                     {{HeRu::RU_996_TONE, 1, true}, 7, 2}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 4, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 5, 2},  // CC2
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 6, 3},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 7, 2}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{80},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208},
                     std::make_pair(2, 2), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 6 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_996_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 5, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 6, 2},
-                     {{HeRu::RU_996_TONE, 1, true}, 7, 2},
-                     {{HeRu::RU_996_TONE, 1, true}, 8, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 9, 1}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 4, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 5, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 6, 2},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 7, 2},  // CC2
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 9, 1}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{80},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208},
                     std::make_pair(3, 3), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 8 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_996_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 5, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 6, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 7, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 8, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 9, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 10, 1},
-                     {{HeRu::RU_996_TONE, 1, true}, 11, 1}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 4, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 5, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 6, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 7, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 9, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 10, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 11, 1}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{80},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208},
                     std::make_pair(4, 4), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 2 users
-    AddTestCase(
-        new HeSigBDurationTest(
-            {{{HeRu::RU_2x996_TONE, 1, true}, 11, 1}, {{HeRu::RU_2x996_TONE, 1, true}, 10, 4}},
-            VhtPhy::GetVhtMcs5(),
-            MHz_u{160},
-            HeSigBDurationTest::MU_MIMO,
-            {208, 208, 208, 208, 208, 208, 208, 208},
-            std::make_pair(1, 1), // users equally split between the two content channels
-            MicroSeconds(4)),     // one OFDM symbol
-        TestCase::Duration::QUICK);
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 11, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 10, 4}}, // CC2
+                    VhtPhy::GetVhtMcs5(),
+                    MHz_u{160},
+                    0,
+                    MuSigDurationTest::MU_MIMO,
+                    {208, 208, 208, 208, 208, 208, 208, 208},
+                    std::make_pair(1, 1), // users equally split between the two content channels
+                    MicroSeconds(4)),     // one OFDM symbol
+                TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 3 users
     AddTestCase(
-        new HeSigBDurationTest(
-            {{{HeRu::RU_2x996_TONE, 1, true}, 4, 3},
-             {{HeRu::RU_2x996_TONE, 1, true}, 5, 2},
-             {{HeRu::RU_2x996_TONE, 1, true}, 6, 1}},
+        new MuSigDurationTest(
+            {{HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 4, 3},  // CC1
+             {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 5, 2},  // CC2
+             {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 6, 1}}, // CC1
             VhtPhy::GetVhtMcs4(),
             MHz_u{160},
-            HeSigBDurationTest::MU_MIMO,
+            0,
+            MuSigDurationTest::MU_MIMO,
             {208, 208, 208, 208, 208, 208, 208, 208},
             std::make_pair(2, 1), // 2 users in content channel 1 and 1 user in content channel 2
             MicroSeconds(4)),     // one OFDM symbol
         TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 4 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_2x996_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 5, 2},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 6, 3},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 7, 2}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 4, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 5, 2},  // CC2
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 6, 3},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 7, 2}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{160},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208, 208, 208, 208, 208},
                     std::make_pair(2, 2), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 6 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_2x996_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 5, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 6, 2},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 7, 2},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 8, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 9, 1}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 4, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 5, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 6, 2},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 7, 2},  // CC2
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 9, 1}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{160},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208, 208, 208, 208, 208},
                     std::make_pair(3, 3), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 8 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_2x996_TONE, 1, true}, 4, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 5, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 6, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 7, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 8, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 9, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 10, 1},
-                     {{HeRu::RU_2x996_TONE, 1, true}, 11, 1}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 4, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 5, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 6, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 7, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 9, 1},   // CC2
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 10, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 11, 1}}, // CC2
                     VhtPhy::GetVhtMcs4(),
                     MHz_u{160},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {208, 208, 208, 208, 208, 208, 208, 208},
                     std::make_pair(4, 4), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-aggregation-test.cc ns-3.45/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.44/src/wifi/test/wifi-aggregation-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/wifi-aggregation-test.cc	2025-06-01 20:34:45.634702200 -0700
@@ -313,6 +313,7 @@
         if (m_params.standard >= WIFI_STANDARD_80211ax)
         {
             HeCapabilities heCapabilities;
+            heCapabilities.SetChannelWidthSet(0x1);
             heCapabilities.SetMaxAmpduLength((1 << 23) - 1);
             m_managers.at(i)->AddStationHeCapabilities(Mac48Address("00:00:00:00:00:02"),
                                                        heCapabilities);
